/*===========================================================================
							 .
			      .
===========================================================================*/
#include <16F877A.h>
#device ADC=10
#use delay(clock=20000000)
#use i2c(Master,sda=PIN_B7,scl=PIN_B6,RESTART_WDT,SLOW)
#fuses HS, NOWDT, NOLVP, NODEBUG
#byte ADCON0 = 0xFF					//    A.
/*---------------------------------------------------------------------------
									.
---------------------------------------------------------------------------*/
#define Ind_Digit_1 output_low(PIN_C5);buttons();delay_ms(3);output_high(PIN_C5);
#define Ind_Digit_2 output_low(PIN_C4);buttons();delay_ms(3);output_high(PIN_C4);
#define Ind_Digit_3 output_low(PIN_C6);buttons();delay_ms(3);output_high(PIN_C6);
//#define Ind_Digit_4 output_low(PIN_A3);buttons();delay_ms(3);output_high(PIN_A3);
#define Ind_Dig_1 output_low(PIN_C5);delay_ms(3);output_high(PIN_C5);
#define Ind_Dig_2 output_low(PIN_C4);delay_ms(3);output_high(PIN_C4);
#define Ind_Dig_3 output_low(PIN_C6);delay_ms(3);output_high(PIN_C6);
//#define Ind_Dig_4 output_low(PIN_A3);delay_ms(3);output_high(PIN_A3);

#define CLK	output_high(PIN_C7);delay_us(1);output_low(PIN_C7);Ind[0]>>=1;
#define DATA_1 output_high(PIN_D3);
#define DATA_0 output_low(PIN_D3);

#define Conv_High high++;low-=10;num[2]=low;num[1]=high;
#define Conv_Mitt high++;low-=10;num[3]=low;num[2]=high;
#define Conv_Low  high++;low-=10;num[4]=low;num[3]=high;
#define Clear_Num num[1]=0;num[2]=0;num[3]=0;num[4]=0;

#define LOAD_DIG_1 Digit_1[0]=Digit_1[d];tablica_simbol_Ind_1();Ind[1]=Digit_1[0];
#define LOAD_DIG_2 Digit_2[0]=Digit_2[d];tablica_simbol_Ind_2();Ind[2]=Digit_2[0];
#define LOAD_DIG_3 Digit_3[0]=Digit_3[d];tablica_simbol_Ind_3();Ind[3]=Digit_3[0];

#define IN_Dig_1 num[0]=Celsio[0];WORD_to_BCD();Digit_1[1]=num[2];Digit_1[2]=num[3];Digit_1[3]=num[4];
#define IN_Dig_2 Celsio[0]=Cels[0];Conv_Cels();Digit_2[1]=num[2];Digit_2[2]=num[3];Celsio[0]=Cels[1]/1.6;Digit_2[3]=Celsio[0];
#define IN_Dig_3 Celsio[0]=Cels[0];Conv_Cels();Digit_3[1]=num[2];Digit_3[2]=num[3];Celsio[0]=Cels[1]/1.6;Digit_3[3]=Celsio[0];

#define POMPE_ON  output_low(PIN_E0);
#define POMPE_OFF output_high(PIN_E0);
#define L_1_ON  output_low(PIN_E2);
#define L_1_OFF output_high(PIN_E2);
#define L_2_ON  output_low(PIN_E1);
#define L_2_OFF output_high(PIN_E1);
#define L_3_ON  output_low(PIN_A5);
#define L_3_OFF output_high(PIN_A5);
#define RED_1_ON  output_low(PIN_B0);
#define RED_1_OFF output_high(PIN_B0);
#define RED_2_ON  output_low(PIN_B2);
#define RED_2_OFF output_high(PIN_B2);
#define RED_3_ON  output_low(PIN_B4);
#define RED_3_OFF output_high(PIN_B4);
#define Cooler_ON output_high(PIN_A2);
#define Cooler_OFF output_low(PIN_A2);
#define Rele_ON output_high(PIN_D1);
#define Rele_OFF output_low(PIN_D1);
#define BLUE_ON  output_low(PIN_B1);
#define BLUE_OFF output_high(PIN_B1);

#define SB1 PIN_D4
#define SB2 PIN_D5
#define SB3 PIN_D6
#define SB4 PIN_D7
#define SB5 PIN_C1

#define DS_1 PIN_D0
#define DS_2 PIN_C3
#define DS_3 PIN_C2

#define Bip_ON output_low(PIN_D2);
#define Bip_OFF output_high(PIN_D2);
#define Bipper Bip_ON;delay_ms(1);Bip_OFF;
/*---------------------------------------------------------------------------
								 
---------------------------------------------------------------------------*/
unsigned char Constants[]  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned char Const_Temp[] = {0,40,20,2,0,4,40,0,10,20,0,75,120,0};
unsigned char Limit[]     = {0,90,40,10,2,30,50,1,20,50,1,90,240,1};
/*---------------------------------------------------------------------------
 	 Const_Temp[1]	-	   .
	 Const_Temp[2]	-	   .
1  - Const_Temp[3]	-	  / ( - 1...10 ).
2  - Const_Temp[4]	-	  / (0,1,2).(  )
					0 -  .
					1 -   .
					2 -   .
3  - Const_Temp[5]	-	   (1..(4)..30 ).
4  - Const_Temp[6]	-	   (40 ).
5  - Const_Temp[7]	-	    1.
					0 - .
					1 - .
6  - Const_Temp[8]	-	   ./. .
7  - Const_Temp[9]	-	   .
8  - Const_Temp[10]	-	      .
					0 - .
					1 - .
9  - Const_Temp[11]	-	     (80 ).
10 - Const_Temp[12]	-	  . .
11 - Const_Temp[13]	-	 .
					0 -  .
					1 -  .
---------------------------------------------------------------------------*/
unsigned char flags_L = 0;				//   .
unsigned char flags = 0;
/*---------------------------------------------------------------------------
flags, 0	-	   .
flags, 1	-	     .
flags, 2	-	 /     .
flags, 3	-	   .
flags, 4	-	   .
flags, 5	-	 
---------------------------------------------------------------------------*/
//unsigned char flag_Dobega = 0;

unsigned char Digit_1[] = {0,0,0,0};	// .    .
unsigned char Digit_2[] = {0,0,0,0};	// .    .
unsigned char Digit_3[] = {0,0,0,0};	// .    .
//unsigned char Digit_4[] = {0,0,0,0};	// .    .
unsigned char Ind[] = {0,0,0,0,0};

unsigned char d = 0;					// d -   .
unsigned char i = 0;
unsigned char f = 0;
unsigned char bit_mask = 1;				//    .
unsigned int16 num[] = {0,0,0,0,0};		//  .
unsigned char adress = 13;				//   EEPROM.
unsigned char  buttons = 0;

unsigned int16 Celsio[] = {0,0,0,0,0,0,0};
unsigned char Cels[] = {0,0};
unsigned char Celsio_1[] = {0,0,0};
unsigned char Celsio_2[] = {0,0,0};
unsigned char Celsio_3[] = {0,0,0};
unsigned char Cels_Ind[] = {0,0};
unsigned char Delta_Cels = 0;
unsigned char Dobeg[] = {0,0};
unsigned char Dobeg_Time[] = {0,0};
unsigned char Dobeg_Cels[] = {0,0};
unsigned char Razogrev_Cels = 0;
unsigned char Control_Cels = 0;
unsigned int16 cnt_Cooler_OFF = 0;

unsigned int16 cnt_time_2[] = {0,0};	//     .2.
unsigned int16 cnt_time_3[] = {0,0};	//     .3.
//unsigned char cnt_reset = 100;
unsigned char cnt_button = 0;			//    .
unsigned char cnt_sell_regim = 0;		//   .

unsigned char high = 0;			//     .
unsigned char low = 0;
unsigned char Time_1[] = {77,0,0,0,0};
/*---------------------------------------------------------------------------
							 .
---------------------------------------------------------------------------*/
#include "1-WIRE.c"						//     1-WIRE.
#include "Tab_Simb.c"					//  .
/*---------------------------------------------------------------------------
								  TMR0.
---------------------------------------------------------------------------*/
#int_TIMER0
void  TIMER0_isr(void) 
{
	Time_1[1]++;
	if (Time_1[1] >= Time_1[0])			//  .
	{
		Time_1[1] = 0;
		Time_1[2]++;
	}
	if (Time_1[2] >= 60)				//  .
	{
		Bipper
		Time_1[2] = 0;
		Time_1[3]++;
	}
}
/*===========================================================================
								.
===========================================================================*/
void WORD_to_BCD();
void read_memory();
void write_memory();
void indic();
void buttons();
void Indicator();
void Multimetr_Canal_0();
void tablica_simbol_Ind_1();
void tablica_simbol_Ind_2();
void tablica_simbol_Ind_3();
void compare();
void compare_job();
void Sellect_Perametr();
void TENS_ON();
void TENS_OFF();
void Load_Constants();
void Pompe_Dobeg();
void Limit_Control_M();
void Limit_Control_P();
/*-------------------------------------------------------------------------*/
void main()
{
	port_b_pullups(TRUE);			//   
									//   .
	setup_adc(ADC_CLOCK_DIV_32);	// ADCON0
	set_tris_a(0x00);				// RA5,4,1,0 - , RA3,2 - .
	set_tris_b(0x00);   			// RB7-1 - , RB0 - .
	set_tris_c(0x00);				// RC7-0 - .
	set_tris_d(0xF0);				// RD7-4 - , RD3-0 - .
	set_tris_e(0x00);
	Bip_OFF
	output_high(PIN_E0);
	output_high(PIN_E1);
	output_high(PIN_E2);
	output_high(PIN_A5);
	output_high(PIN_B0);
	output_high(PIN_B1);
	output_high(PIN_B2);
	output_high(PIN_B3);
	output_high(PIN_B4);
	read_memory();					//  EEPROM.
	if (Constants[1] == 0xFF)		//  EEPROM ,  
	{
		for (i = 0; i <= adress; i++)   //      EEPROM.
		{
			Constants[i] = Const_Temp[i];
			write_eeprom(i,Constants[i]);
		}
	}
	Load_Constants();
	delay_ms(200);
	Bipper
/*---------------------------------------------------------------------------
								 .
---------------------------------------------------------------------------*/
	do
	{
		DS18B20_1();				//    .
		DS18B20_2();				//    .
		DS18B20_3();				//    .
		indic();					//  .
		compare();					//   .
		Pompe_Dobeg();
//---------------------------------------------------------------------------
		if (flags_L > 0)
		{
			Cooler_ON				//  .
		}
		else						// 
		{
			if (Time_1[3] >= 1)
			{
				Cooler_OFF			//  .
				cnt_sell_regim = 0;
			}
		}
//---------------------------------------------------------------------------
		if (cnt_button > 0)
		{
			cnt_button--;
		}
		if (Time_1[3] >= 1)
		{
			bit_clear(flags,0);	//   . .
		}
		setup_timer_0(RTCC_INTERNAL|RTCC_DIV_256);
		enable_interrupts(INT_TIMER0);
		enable_interrupts(GLOBAL);
	}
	while(1);						//  .
}
/*===========================================================================
							  .
===========================================================================*/
void Pompe_Dobeg()
{
	if (Dobeg[1] == 1)
	{
		switch(Dobeg[0])
		{
/*-------------------------------------------------------------------------*/
			case 1:
 					if (Time_1[3] >= Dobeg_Time[0])
					{
						POMPE_OFF
						BLUE_OFF
						Dobeg[1] = 0;
					}
			break;
/*-------------------------------------------------------------------------*/
			case 2: 
 					if (Celsio_1[1] <= Dobeg_Cels[0])
					{
						POMPE_OFF
						BLUE_OFF
						Dobeg[1] = 0;
					}				
			break;
/*-------------------------------------------------------------------------*/
		}
	}
	return;
}
/*===========================================================================
							  .
===========================================================================*/
void Load_Constants()
{
	Celsio[4]  = Constants[1];
	Celsio[5]  = Constants[2];
	Delta_Cels = Constants[3];
	Dobeg[0] = Constants[4];
	Dobeg_Time[0] = Constants[5];
	Dobeg_Cels[0] = Constants[6];
	cnt_time_2[0] = Constants[8];
	cnt_time_2[0] = cnt_time_2[0] << 4;
	cnt_time_2[1] = Constants[8];
	cnt_time_2[1] = cnt_time_2[1] << 4;
	cnt_time_3[0] = Constants[8];
	cnt_time_3[0] = cnt_time_3[0] << 4;
	cnt_time_3[1] = Constants[8];
	cnt_time_3[1] = cnt_time_3[1] << 4;
	cnt_button = Constants[9];
	Razogrev_Cels = Constants[11];
	cnt_Cooler_OFF = Constants[12];
	cnt_Cooler_OFF = cnt_Cooler_OFF << 4; 
	Control_Cels = Constants[13];
	return;
}
/*===========================================================================
							  .
===========================================================================*/
void compare()
{
	switch(presence_ds18b20_3)
	{								// T  .
		case 0: Celsio[0] = Celsio[4]; Celsio_1[0] = Celsio_1[1]; break;
		case 1: Celsio[0] = Celsio[5]; Celsio_1[0] = Celsio_3[1]; break;
	}								// T  .
	switch(Control_Cels)
	{								// T  .
		case 1: Celsio[0] = Celsio[4]; Celsio_1[0] = Celsio_2[1]; break;
	}
/*-------------------------------------------------------------------------*/
	switch(bit_test(Constants[10],0) == 1)//     
	{
		case 0: bit_clear(flags,1); bit_clear(flags,2); POMPE_ON; break;
		case 1: bit_set(flags,1); break;	//   .
	}
/*-------------------------------------------------------------------------*/
	if (Constants[7] == 1)			//  .  . . 1.
	{
		L_1_ON						//   . 1.
		RED_1_ON					//     1.
		bit_set(flags_L,1);
	}
/*-------------------------------------------------------------------------*/
	if (bit_test(flags,2) == 1)		//    
	{								//    ,
		Celsio[0] = Razogrev_Cels;	//   . .
	}
/*=========================================================================*/
	if (Celsio_1[0] >= Celsio[0])	//   . >= ,
	{
		if (bit_test(flags,1) == 1)	//    , 
		{
			bit_clear(flags,2);		//   2 
			POMPE_ON				//  .
			BLUE_ON
		}
		bit_set(flags,3);
		bit_clear(flags,4);
	}
/*-------------------------------------------------------------------------*/
	if (Celsio_1[0] <= Celsio[0] - Delta_Cels)	// .
	{
		if (bit_test(flags,1) == 1)
		{
			bit_set(flags,2);		//   2 
			POMPE_OFF				//  .
			BLUE_OFF
		}
		bit_clear(flags,3);
		bit_set(flags,4);
	}
/*-------------------------------------------------------------------------*/
	if (bit_test(flags,4) == 1)
	{
		TENS_ON();					//  .
	}
	if (bit_test(flags,3) == 1)
	{
		TENS_OFF();					//  .
	}
/*=========================================================================*/
	Cels_Ind[0] = Celsio_1[0];		//   . .
	if (Cels_Ind[0] == Cels_Ind[1])	//    .
	{
		return;						//   , .
	}
	if (Cels_Ind[0] > Cels_Ind[1])	//    
	{								// , 
		Cels_Ind[1] = Cels_Ind[0];	//   .
		output_low(PIN_B3);			//   .
	}
	if (Cels_Ind[0] < Cels_Ind[1])	//    
	{								// , 
		Cels_Ind[1] = Cels_Ind[0];	//   .
		output_high(PIN_B3);		//   .
	}
	return;
}
/*===========================================================================
							 ./. .
===========================================================================*/
void TENS_ON()
{
	POMPE_ON
	BLUE_ON
	Dobeg[1] = 0;
	L_1_ON								//   . 1.
	RED_1_ON							//     1.
	bit_set(flags_L,1);
/*-------------------------------------------------------------------------*/
	if (Constants[7] == 0)
	{
		if (cnt_time_2[1] > 0)
		{
			cnt_time_2[1]--;
			if (cnt_time_2[1] == 0)
			{
				L_2_ON					//   . 2.
				RED_2_ON				//     2.
				bit_set(flags_L,2);
				cnt_time_2[0] = Constants[8];
				cnt_time_2[0] = cnt_time_2[0] << 4;
			}	
		}
	}
	else
	{
		L_2_ON							//   . 2.
		RED_2_ON						//     2.
		bit_set(flags_L,2);
		cnt_time_2[1] = 0;
	}
/*-------------------------------------------------------------------------*/
	if (cnt_time_2[1] == 0)
	{
		if (cnt_time_3[1] > 0)
		{
			cnt_time_3[1]--;
			if (cnt_time_3[1] == 0)
			{
				L_3_ON					//   . 3.
				RED_3_ON				//     3.
				bit_set(flags_L,3);
				cnt_time_3[0] = Constants[8];
				cnt_time_3[0] = cnt_time_3[0] << 4;
				bit_clear(flags,4);
			}
		}
	}
	return;
}
/*=========================================================================*/
void TENS_OFF()
{
	if (Constants[7] == 0)
	{
		L_1_OFF							//   . 1.
		RED_1_OFF						//     1.
		bit_clear(flags_L,1);
	}
/*-------------------------------------------------------------------------*/
	if (Constants[7] == 0)
	{
		if (cnt_time_2[0] > 0)
		{
			cnt_time_2[0]--;
			if (cnt_time_2[0] == 0)
			{
				L_2_OFF					//   . 2.
				RED_2_OFF				//     2.
				bit_clear(flags_L,2);
				cnt_time_2[1] = Constants[8];
				cnt_time_2[1] = cnt_time_2[1] << 4;
			}
		}
	}
	else
	{
		L_2_OFF							//   . 2.
		RED_2_OFF						//     2.
		bit_clear(flags_L,2);
		cnt_time_2[0] = 0;
	}
/*-------------------------------------------------------------------------*/
	if (cnt_time_2[0] == 0)
	{
		if (cnt_time_3[0] > 0)
		{
			cnt_time_3[0]--;
			if (cnt_time_3[0] == 0)
			{
				L_3_OFF					//   . 3.
				RED_3_OFF				//     3.
				bit_clear(flags_L,3);
				cnt_time_3[1] = Constants[8];
				cnt_time_3[1] = cnt_time_3[1] << 4;
				bit_clear(flags,3);
				Time_1[1] = 0;
				Time_1[2] = 0;
				Time_1[3] = 0;
				Dobeg[1] = 1;
			}
		}
	}
	return;
}
/*===========================================================================
                         .
===========================================================================*/
void Conv_Cels()
{
	num[1] = 0;
	low = Celsio[0];
	high = 0;
	num[3] = low;
	while (num[3] >= 10)
	{
		Conv_Mitt
	}
	num[2] = high;
	high = 0;
	while (num[2] >= 10)
	{
		high++;
		num[2] -= 10;
		num[1] = high;
	}
	return;
}
/*===========================================================================
								  .
===========================================================================*/
void buttons()
{
	if (cnt_button == 0)
	{
/*-------------------------------------------------------------------------*/
		if (input(SB1) == 0) 		//    SB1.
		{
			Time_1[1] = 0;
			Time_1[2] = 0;
			Time_1[3] = 0;
			bit_set(flags,0);		//    .
			if (cnt_sell_regim <= adress - 3)
			{
				cnt_sell_regim++;
			}
			else
			{
				cnt_sell_regim = 0;
				bit_clear(flags,0);
			}
			Bipper
		}
/*-------------------------------------------------------------------------*/
		if (input(SB2) == 0) 		//    SB2,  
		{
			Time_1[4] = 0;
			d = 1;
			while (input(SB2) == 0)
			{
				if (Time_1[4] >= 5)
				{
					for (i = 0; i <= adress; i++)
					{
						Constants[i] = Const_Temp[i];
						Bipper
					}
				}
				switch(d)
				{
					case 1: Ind_Dig_1; break;
					case 2: Ind_Dig_2; break;
					case 3: Ind_Dig_3; break;
//					case 4: Ind_Dig_4; break;
				}
				if (d >= 3)			// 
				{
					d = 0;
				}
				d++;
			}
			cnt_sell_regim = 0;
			bit_clear(flags,0);
			write_memory();			//     .
			Load_Constants();
			Bipper
		}
/*-------------------------------------------------------------------------*/
		if (input(SB3) == 0) 		//    SB3,  .
		{
			if (bit_test(flags,0) == 0)
			{
				switch(presence_ds18b20_3)		//  .
				{
					case 0:
							Constants[1]--;
							cnt_sell_regim = 1;
							Limit_Control_M();
							cnt_sell_regim = 0;
							Celsio[4] = Constants[1];
					break;
					case 1:
							Constants[2]--;
							cnt_sell_regim = 2;
							Limit_Control_M();
							cnt_sell_regim = 0;
							Celsio[5] = Constants[2];
					break;
				}
			}
			else
			{
				switch(cnt_sell_regim)
				{
					case 1:  Constants[3]--;  Limit_Control_M(); break;
					case 2:  Constants[4]--;  Limit_Control_M(); break;
					case 3:  Constants[5]--;  Limit_Control_M(); break;
					case 4:  Constants[6]--;  Limit_Control_M(); break;
					case 5:  Constants[7]--;  Limit_Control_M(); break;
					case 6:  Constants[8]--;  Limit_Control_M(); break;
					case 7:  Constants[9]--;  Limit_Control_M(); break;
					case 8:  Constants[10]--; Limit_Control_M(); break;
					case 9:  Constants[11]--; Limit_Control_M(); break;
					case 10: Constants[12]--; Limit_Control_M(); break;
					case 11: Constants[13]--; Limit_Control_M(); break;
				}
				Load_Constants();
			}
			Bipper
		}				
/*-------------------------------------------------------------------------*/
		if (input(SB4) == 0) 		//    SB4,  .
		{
			if (bit_test(flags,0) == 0)
			{
				switch(presence_ds18b20_3)		//  .
				{
					case 0: 
							Constants[1]++;
							cnt_sell_regim = 1;
							Limit_Control_P();
							cnt_sell_regim = 0;
							Celsio[4] = Constants[1];
					break;
					case 1:
							Constants[2]++;
							cnt_sell_regim = 2;
							Limit_Control_P();
							cnt_sell_regim = 0;
							Celsio[5] = Constants[2];
					break;
				}
			}
			else
			{
				switch(cnt_sell_regim)
				{
					case 1:  Constants[3]++;  Limit_Control_P(); break;
					case 2:  Constants[4]++;  Limit_Control_P(); break;
					case 3:  Constants[5]++;  Limit_Control_P(); break;
					case 4:  Constants[6]++;  Limit_Control_P(); break;
					case 5:  Constants[7]++;  Limit_Control_P(); break;
					case 6:  Constants[8]++;  Limit_Control_P(); break;
					case 7:  Constants[9]++;  Limit_Control_P(); break;
					case 8:  Constants[10]++; Limit_Control_P(); break;
					case 9:  Constants[11]++; Limit_Control_P(); break;
					case 10: Constants[12]++; Limit_Control_P(); break;
					case 11: Constants[13]++; Limit_Control_P(); break;
				}
				Load_Constants();
			}
			Bipper
		}				
		cnt_button = Constants[9];
	}
/*-------------------------------------------------------------------------*/
	switch(input(SB5)) 				//     ,
	{
		case 0: Rele_OFF; break;	//    ,
		case 1: Rele_ON;  break;	// ,   .
	}
	return ;
}
/*===========================================================================
				    .
===========================================================================*/
void Limit_Control_M()
{
	if (Constants[cnt_sell_regim] == 0xFF)
	{
		Constants[cnt_sell_regim] = 0;
	}
	return;
}
/*-------------------------------------------------------------------------*/
void Limit_Control_P()
{
	if (Constants[cnt_sell_regim] >= Limit[cnt_sell_regim])
	{
		Constants[cnt_sell_regim] = Limit[cnt_sell_regim];
	}
	return;
}
/*===========================================================================
						    .
===========================================================================*/
void indic()
{
	for (d = 1; d < 4; d++)				//  .
//	for (d = 1; d < 5; d++)				//  .
	{
/*---------------------------------------------------------------------------
								 1.
---------------------------------------------------------------------------*/
		if (bit_test(flags,0) == 0)
		{
			switch(presence_ds18b20_3)
			{							//    .
				case 0: Celsio[0] = Celsio[4]; break;
				case 1: Celsio[0] = Celsio[5]; break;
			}							//    .
		}
		else							//   .
		{
			switch(cnt_sell_regim)
			{
				case 1:  Celsio[0] = Constants[3];  break;
				case 2:  Celsio[0] = Constants[4];  break;
				case 3:  Celsio[0] = Constants[5];  break;
				case 4:  Celsio[0] = Constants[6];  break;
				case 5:  Celsio[0] = Constants[7];  break;
				case 6:  Celsio[0] = Constants[8];  break;
				case 7:  Celsio[0] = Constants[9];  break;
				case 8:  Celsio[0] = Constants[10]; break;
				case 9:  Celsio[0] = Constants[11]; break;
				case 10: Celsio[0] = Constants[12]; break;
				case 11: Celsio[0] = Constants[13]; break;
			}
		}
		IN_Dig_1						//    1.
		LOAD_DIG_1						//    1.
/*---------------------------------------------------------------------------
								 2.
---------------------------------------------------------------------------*/
		if (bit_test(flags,0) == 0)
		{
			switch(presence_ds18b20_3)
			{							//    .
				case 0: Cels[0] = Celsio_1[1]; Cels[1] = Celsio_1[2]; break;
				case 1: Cels[0] = Celsio_3[1]; Cels[1] = Celsio_3[2]; break;
			}							//    .
			switch(Control_Cels)
			{							// T  .
				case 1: Cels[0] = Celsio_2[1]; Cels[1] = Celsio_2[2]; break;
			}

		}
		else							//   .
		{
			Cels[0] = 0;
			switch(cnt_sell_regim)
			{
				case 1:  Cels[1] = 2;  break;
				case 2:  Cels[1] = 4;  break;
				case 3:  Cels[1] = 5;  break;
				case 4:  Cels[1] = 7;  break;
				case 5:  Cels[1] = 8;  break;
				case 6:  Cels[1] = 10; break;
				case 7:  Cels[1] = 12; break;
				case 8:  Cels[1] = 13; break;
				case 9:  Cels[1] = 15; break;
				case 10: Cels[1] = 1.6; Cels[0] = 1; break;
				case 11: Cels[1] = 2;   Cels[0] = 1; break;
			}
		}
		IN_Dig_2						//    2.
		LOAD_DIG_2						//    2.
		if (d == 2)
		{
			if (bit_test(flags,0) == 0)
			{
				bit_set(Ind[2],1);		//   .
			}
		}
		switch(presence_ds18b20_3)
		{
			case 0:
				switch(presence_ds18b20_1)
				{
					case 0: Ind[2] = 0x20; break;
				}
			break;
		}
/*---------------------------------------------------------------------------
								 3.
---------------------------------------------------------------------------*/
		switch(presence_ds18b20_3)
		{								// T  .
			case 0: Cels[0] = Celsio_2[1]; Cels[1] = Celsio_2[2]; break;
			case 1: Cels[0] = Celsio_1[1]; Cels[1] = Celsio_1[2]; break;
		}								// T  .
		switch(Control_Cels)
		{								// T  .
			case 1: Cels[0] = Celsio_1[1]; Cels[1] = Celsio_1[2]; break;
		}
		IN_Dig_3						//    3.
		LOAD_DIG_3						//    3.
		if (d == 2)
		{
			bit_set(Ind[3],1);			//   .
		}
		switch(presence_ds18b20_1)
		{
			case 0:
					switch(presence_ds18b20_2)
					{
						case 0: Ind[3] = 0x20; break;
					}
			break;
		}
		switch(presence_ds18b20_3)
		{
			case 0:
					switch(presence_ds18b20_2)
					{
						case 0: Ind[3] = 0x20; break;
					}
			break;
		}
		switch(presence_ds18b20_3)
		{
			case 1:
					switch(presence_ds18b20_1)
					{
						case 0: Ind[3] = 0x20; break;
					}
			break;
		}
/*---------------------------------------------------------------------------
								 .
---------------------------------------------------------------------------*/
		Indicator();
		switch(d)
		{
			case 1: Ind_Digit_1; break;
			case 2: Ind_Digit_2; break;
			case 3: Ind_Digit_3; break;
//			case 4: Ind_Digit_4; break;
		}
//---------------------------------------------------------------------------
	}
	return;						//      .
}
/*===========================================================================
							  EEPROM.
===========================================================================*/
void read_memory()
{
	for (i = 0; i <= adress; i++)
	{
		Constants[i] = read_eeprom(i);
	}
	return;
}
/*===========================================================================
							  EEPROM.
===========================================================================*/
void write_memory()
{
	for (i = 0; i <= adress; i++)		//      EEPROM.
	{
		write_eeprom(i,Constants[i]);
	}
	return;
}
/*===========================================================================
						    .
===========================================================================*/
void Indicator()
{
	bit_mask = 1;
	Ind[0] = Ind[3];
	for (f = 0; f < 8; f++)			//     3.
	{
		switch(Ind[0] & bit_mask)
		{
			case 0: DATA_0; break;
			case 1: DATA_1; break;
		}
		CLK	
	}								// a  .
//---------------------------------------------------------------------------
	Ind[0] = Ind[2];
	for (f = 0; f < 8; f++)			//     2.
	{
		switch(Ind[0] & bit_mask)
		{
			case 0: DATA_0; break;
			case 1: DATA_1; break;
		}
		CLK
	}								// a  .
//---------------------------------------------------------------------------
	Ind[0] = Ind[1];
	for (f = 0; f < 8; f++)			//     1.
	{
		switch(Ind[0] & bit_mask)
		{
			case 0: DATA_0; break;
			case 1: DATA_1; break;
		}
		CLK
	}								// a  .
	DATA_0
	return;
}
/*===========================================================================
                         BCD e.
===========================================================================*/
void WORD_to_BCD()
{
	Clear_Num
	low = num[0];
	high = 0;
	num[4] = low;
	while (num[4] >= 10)
	{
		Conv_Low
	}
	low = high;
	high = 0;
	while (num[3] >= 10)
	{
		Conv_Mitt
	}
	low = high;
	high = 0;
	while (num[2] >= 10)
	{
		Conv_High 
	}
	return;
}
/*=========================================================================*/